<?php
class Bib {
    public static function ping ($tip, $pathServ, $port) {
        return "PHP " . $tip . " " .
                $pathServ . ": " . $_SERVER["SERVER_NAME"] . " (" .
                gethostbyname($_SERVER["SERVER_NAME"]) . ":" .
                $port . "), " . date("Y.m.d H:i:s");
    }
    public static function add($a, $b) {
        return $a + $b;
    }
    public static function subtract($a, $b) {
        return $a - $b;
    }
    public static function multiply($a, $b) {
        return $a * $b;
    }
    public static function divide($a, $b) {
        if ($b == 0) return "ERROR divide: Impartire la zero";
        return (int)($a / $b);
    }
    public static function mod($a, $b) {
        if ($b == 0) return "ERROR mod: Impartire la zero";
        return $a % $b;
    }
    public static function intPow($a, $b) {
        $p=1;
        for ($i=1; $i <= $b; $i++) $p *= $a;
        return $p;
    }
    public static function toFpp($infix) {
        $infix = trim($infix);
        $varf =-1;
        $postfix = "";
        $eval = "";
        $apeluri = "";
        $operatori = "+-*/%^";
        $priority = "112223";
        $albe = " \t\n\r";
        $alfabet = "0123456789".$operatori.$albe."()";
        $stiva = array();
        $operanzi = array();
        $sb = $infix;
        for ( $i=strlen($sb)-1; $i>=0; $i--) {
            $c = $sb[$i];
            if (strpos($alfabet, $c) === false) return $infix . "\nERROR caracter interzis!\n";
            if (!(strpos($albe, $c) === false)) $sb = substr($sb, 0, $i).substr($sb,$i+1);
            if ($i < strlen($sb)-1) $u = $sb[$i+1]; else $u = ' ';
            if ($c == '(')
                if ($u == '+')
                $sb = substr($sb, 0, i+1).substr($sb,i+2);
            else if ($u == '-')
                $sb = substr($sb, 0, $i+1)."0".substr($sb,$i+1);
        } // Control alfabet, sters toate spatiile albe, rezolvat + si - unar
        if (strlen($sb) > 0)
            if ($sb[0] == '+')
            $sb = substr($sb,1);
        else if ($sb[0] == '-')
            $sb = "0".$sb;
        for ( ; strlen($sb) >0; ) {
            $c = $sb[0];
            $i = strpos($operatori, $c);
            if (is_numeric($c)) { // operand
                for ( $i=0; $i < strlen($sb) && is_numeric($sb[$i]); $i++) ;
                $postfix .= "#".substr($sb,0,$i)."|";
                $eval .= "#";
                $sb = substr($sb, $i-1);
            } else if (!($i === false)) { // operatori
                for ( ; ; ) {
                    if ($varf < 0) break;
                    $p = strpos($operatori, $stiva[$varf]);
                    if ($p === false || $priority[$p] < $priority[$i]) break;
                    $p = strlen($eval);
                    if ($p < 2) return $infix . "\nERROR operatori fara operanzi\n";
                    $postfix .= $stiva[$varf];
                    $eval = substr($eval, 0, $p-1);
                    $varf--;
                }
                $varf++;
                $stiva[$varf] = $c;
            } else if ($c == '(') { // pune ( in stiva
                $varf++;
                $stiva[$varf] = $c;
            } else if ($c == ')') { // extrage din stiva pana la ( si genereaza corespunzator
                for ( ;  ;  ) {
                    if ($varf < 0) return $infix . "\nERROR paranteze incorecte!\n";
                    $c = $stiva[$varf];
                    $varf--;
                    if ($c == '(') break;
                    $p = strlen($eval);
                    if ($p < 2) return $infix . "\nERROR operatori fara operanzi\n";
                    $postfix .= $c;
                    $eval = substr($eval, 0, $p-1);
                }
            }
            $sb = substr($sb, 1);
        }
        for ( ; $varf >= 0;  ) { // golestre stiva de ultimii operatori si genereaza
            if ($stiva[$varf] == '(') return $infix . "\nERROR paranteze incorecte!\n";
            $p = strlen($eval); // !!! DVA
            if ($p < 2) return $infix . "\nERROR operatori fara operanzi\n" . $eval . $varf . $p;
            $eval = substr($eval, 0, $p-1);
            $postfix .= $stiva[$varf];
            $varf--;
        }
        if (strlen($eval) != 1) return $infix . "\nERROR prea multi operanzi\n";
        $sb = $postfix;
        $p = 0;
        $varf = -1;
        for ( ; strlen($sb) >0; ) { // construieste succesiunea de apeluri
            $c = $sb[0];
            if ($c == '#') {
                $i = strpos($sb, "|");
                $varf++;
                $operanzi[$varf] = "\"".substr($sb,1,$i-1)."\"";
                $sb = substr($sb, $i+1);
            } else {
                $sb = substr($sb, 1);
                $d = $operanzi[$varf];
                $s = $operanzi[$varf-1];
                if ($s[0] == "\"" && $d[0] == "\"") $r = "".$p++;
                else if ($s[0] == "\"") $r = $d;
                else $r = $s;
                $operanzi[$varf-1] = $r;
                $varf--;
                $apeluri .= $r."=".$s.$c.$d."\n";
            }
        }
        $apeluri .= $operanzi[0]."\n";
        return $apeluri . $postfix . "\n" . $infix;
    }
}
?>
