<?php
require_once ('RestServer.php');
require_once ('Bib.php');
class ServiceRh implements RestController {
    private $rest;
    public function execute(RestServer $rest) {
        return $rest;
    } // Vida, nefolosita, dar trebuie
    function ping(RestServer $rest) {
        $rest->getResponse()->setResponse(Bib::ping("RESTful", "ServiceRh", "80"));
        return $rest ;
    }
    function add(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::add($a, $b));
        return $rest ;
    }
    function subtract(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::subtract($a, $b));
        return $rest ;
    }
    function multiply(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::multiply($a, $b));
        return $rest ;
    }
    function divide(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::divide($a, $b));
        return $rest ;
    }
    function mod(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::mod($a, $b));
        return $rest ;
    }
    function intPow(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(Bib::intPow($a, $b));
        return $rest ;
    }
    function toFpp(RestServer $rest) {
        $s = $rest->getRequest()->getPost();
        $rest->getResponse()->setResponse(Bib::toFpp($s["infix"]));
        return $rest ;
    }
    function init() {
        $this->rest = new RestServer();
        $this->rest->addMap("GET",  "/ServiceRh.php/ping", "ServiceRh::ping");
        $this->rest->addMap("PUT",  "/ServiceRh.php/add/-?[0-9]+/-?[0-9]+", "ServiceRh::add");
        $this->rest->addMap("PUT",  "/ServiceRh.php/subtract/-?[0-9]+/-?[0-9]+", "ServiceRh::subtract");
        $this->rest->addMap("PUT",  "/ServiceRh.php/multiply/-?[0-9]+/-?[0-9]+", "ServiceRh::multiply");
        $this->rest->addMap("PUT",  "/ServiceRh.php/divide/-?[0-9]+/-?[0-9]+", "ServiceRh::divide");
        $this->rest->addMap("PUT",  "/ServiceRh.php/mod/-?[0-9]+/-?[0-9]+", "ServiceRh::mod");
        $this->rest->addMap("PUT",  "/ServiceRh.php/intPow/-?[0-9]+/-?[0-9]+", "ServiceRh::intPow");
        $this->rest->addMap("POST", "/ServiceRh.php/toFpp", "ServiceRh::toFpp");
    }
    function wait() {
        echo $this->rest->execute();
    }
}
$serv = new ServiceRh();
$serv->init();
$serv->wait();
?>
