import cherrypy
import sys
import Bib
import Hurl
class ServiceRy:
    @cherrypy.expose
    def ping(self):
        if cherrypy.request.method == "GET": 
            return Bib.ping("REESTful", "ServiceRy", "3004")
    @cherrypy.expose
    def add(self, *args, **kwargs):
        if cherrypy.request.method == "PUT":
            return `Bib.add(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def subtract(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `Bib.subtract(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def multiply(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `Bib.multiply(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def divide(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `Bib.divide(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def mod(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `Bib.mod(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def intPow(self, *args, **kwargs):
        if cherrypy.request.method == "PUT": 
            return `Bib.intPow(int(args[0]), int(args[1]))`
    @cherrypy.expose
    def toFpp(self, *args, **kwargs):
        if cherrypy.request.method == "POST": 
            return Bib.toFpp(kwargs['infix'])
    def __init__(self, urlServ):
        url = Hurl.hurl(urlServ)
        cherrypy.server.socket_port = int(url["port"])
        cherrypy.server.socket_host = url["host"]
        print "Python RESTful ServiceRy waiting at:" + urlServ  
        cherrypy.quickstart(self)
if len(sys.argv) > 1: 
    ServiceRy(sys.argv[1])
else:
    ServiceRy("http://0.0.0.0:3004")
