from SimpleXMLRPCServer import SimpleXMLRPCServer
import sys
import Bib
import Hurl
class ServiceXy:
    def ping(self):
        return Bib.ping("XML-RPC", "ServiceXy", "1004")
    def __init__(self, urlServ):
        url = Hurl.hurl(urlServ)
        pathServ = url["path"]
        port = int(url["port"])
        serviciu = SimpleXMLRPCServer((url["host"], port))
        serviciu.register_function(self.ping, pathServ + ".ping")
        serviciu.register_function(Bib.add, pathServ + ".add")
        serviciu.register_function(Bib.subtract, pathServ + ".subtract")
        serviciu.register_function(Bib.multiply, pathServ + ".multiply")
        serviciu.register_function(Bib.divide, pathServ + ".divide")
        serviciu.register_function(Bib.mod, pathServ + ".mod")
        serviciu.register_function(Bib.intPow, pathServ + ".intPow")
        serviciu.register_function(Bib.toFpp, pathServ + ".toFpp")
        print "Python XML-RPC service" + pathServ + " waiting at: " + urlServ
        serviciu.serve_forever()
if len(sys.argv) > 2:
    ServiceXy(sys.argv[1])
else:
    ServiceXy("http://0.0.0.0:1004/Xy")
