import xmlrpclib
import sys
import Hurl
class XyC:
    def __init__(self, urlServ):  
        url = Hurl.hurl(urlServ)
        self.pathServ = url["path"]
        if self.pathServ.endswith(".php"): 
            self.pathServ = ""
            self.serviciu = xmlrpclib.ServerProxy("http://" + url["host"] + \
                ":" + url["port"] + "/" + url["path"])
        else:
            self.pathServ += "."
            self.serviciu = xmlrpclib.ServerProxy("http://" + url["host"] + \
                ":" + url["port"])
    def ping(self):
        try:
            return getattr(self.serviciu, self.pathServ + "ping")()
        except xmlrpclib.Fault, e:
            return e.faultString
    def toFpp(self, infix):
        try:
            return getattr(self.serviciu, self.pathServ + "toFpp")(infix)
        except xmlrpclib.Fault, e:
            return e.faultString
    def calc(self, f, a, b):
        try:
            return `getattr(self.serviciu, self.pathServ + f)(a, b)`
        except xmlrpclib.Fault, e:
            return e.faultString
