using System;
using System.Net;
using System.Text;
using System.Collections;
public static class Bib {
    public static String ping(String tip, String pathServ, String port) {
        String host = Dns.GetHostName();
        return "C# " + tip + " " + pathServ + ": "+host +
            " (" + Dns.GetHostAddresses(host)[0] + ":" + port + ") " + DateTime.Now;
    }
    public static int add(int a, int b) {
        return a + b;
    }
    public static int subtract(int a, int b) {
        return a - b;
    }
    public static int multiply(int a, int b) {
        return a * b;
    }
    public static int divide(int a, int b) {
        try {
            return a / b;
        } catch (Exception e) {
            throw new Exception("divide: Impartire la zero" + e);
        }
    }
    public static int mod(int a, int b) {
        try {
            return a % b;
        } catch (Exception e) {
            throw new Exception("mod: Impartire la zero" + e);
        }
    }
    public static int intPow(int a, int b) {
        int p = 1;
        try {
            for (int i=1; i<= b; i++, p *= a);
            return p;
        } catch (Exception e) {
            throw new Exception("intPow: depasire" + e);
        }
    }
    public static String toFpp(String infix) {
        infix = infix.Trim();
        int i, p, varf =-1;
        char c, u;
        String s, d, r;
        String postfix = "";
        String eval = "";
        String apeluri = "";
        String operatori = "+-*/%^";
        String priority = "112223";
        String albe = " \t\n\r";
        String alfabet = "0123456789"+operatori+albe+"()";
        ArrayList stiva = new ArrayList();
        ArrayList operanzi = new ArrayList();
        StringBuilder sb = new StringBuilder(infix);
        for ( i=sb.Length-1; i>=0; i--) {
            c = sb[i];
            if (alfabet.IndexOf(c) == -1) return infix+"\nERROR caracter interzis!\n";
            if (albe.IndexOf(c) >= 0) sb.Remove(i, 1);
            if (i < sb.Length-1) u = sb[i+1]; else u = ' ';
        if (c == '(')
            if (u == '+')
                sb.Remove(i+1, 1);
            else if (u == '-')
                sb.Insert(i+1, '0');
        } // Control alfabet, sters toate spatiile albe, rezolvat + si - unar
        if (sb.Length > 0)
            if (sb[0] == '+')
                sb.Remove(0, 1);
            else if (sb[0] == '-')
                sb.Insert(0, '0');
        for ( ; sb.Length >0; ) {
            c = sb[0];
            i = operatori.IndexOf(c);
            if (char.IsDigit(c)) { // operand
                for ( i=0; i < sb.Length && char.IsDigit(sb[i]); i++) ;
                postfix += "#" + sb.ToString().Substring(0,i) + "|";
                eval += "#";
                sb.Remove(0,i-1);
            } else if (i != -1) { // operatori
                for ( ; ; ) {
                    if (varf < 0) break;
                    p = operatori.IndexOf(stiva[varf].ToString());
                    if (p < 0 || priority[p] < priority[i]) break;
                    p = eval.Length;
                    if (p < 2) return infix+"\nERROR operatori fara operanzi\n";
                    postfix += stiva[varf];
                    eval = eval.Substring(0, p-1);
                    stiva.RemoveAt(varf);
                    varf--;
                }
                stiva.Add(c);
                varf++;
            } else if (c == '(') { // pune ( in stiva
                stiva.Add(c);
                varf++;
            } else if (c == ')') { // extrage din stiva pana la ( si genereaza corespunzator
                for ( ;  ;  ) {
                    if (varf < 0) return infix+"\nERROR paranteze incorecte!\n";
                    c = (char)stiva[varf];
                    stiva.RemoveAt(varf);
                    varf--;
                    if (c == '(') break;
                    p = eval.Length;
                    if (p < 2) return infix+"\nERROR operatori fara operanzi\n";
                    postfix += c;
                    eval = eval.Substring(0, p-1);
                }
            }
            sb.Remove(0, 1);
        }
        for ( ; varf >= 0;  ) { // golestre stiva de ultimii operatori si genereaza
            if ((char)stiva[varf] == '(') return infix+"\nERROR paranteze incorecte!\n";
            p = eval.Length;
            if (p < 2) return infix+"ERROR operatori fara operanzi\n";
            eval = eval.Substring(0, p-1);
            postfix += stiva[varf];
            stiva.RemoveAt(varf);
            varf--;
        }
        if (eval.Length != 1) return infix+"\nERROR prea multi operanzi\n";
        sb = new StringBuilder(postfix);
        p = 0;
        for ( ; sb.Length >0; ) { // construieste succesiunea de apeluri
            c = sb[0];
            if (c == '#') {
                i = sb.ToString().IndexOf("|");
                operanzi.Add("\""+sb.ToString().Substring(1,i-1)+"\"");
                sb.Remove(0,i+1);
            } else {
                sb.Remove(0, 1);
                varf = operanzi.Count-1;
                d = (String)operanzi[varf];
                s = (String)operanzi[varf-1];
                if (s[0] == '\"' && d[0] == '\"') r = ""+(p++);
                else if (s[0] == '\"') r = d;
                else r = s;
                operanzi[varf-1] = r;
                operanzi.RemoveAt(varf);
                apeluri += r + "=" + s + c + d + "\n";
            }
        }
        apeluri += operanzi[0] + "\n";
        return apeluri + postfix + "\n" + infix;
    } 
}
