using System;
using Nwc.XmlRpc;
using System.Collections;
class ServiceXs {
    public String ping() {
        return Bib.ping("XML-RPC", "ServiceXs", "1001");
    }
    public int add(int a, int b) {
        return Bib.add(a, b);
    }
    public int subtract(int a, int b) {
        return Bib.subtract(a, b);
    }
    public int multiply(int a, int b) {
        return Bib.multiply(a, b);
    }
    public int divide(int a, int b) {
        return Bib.divide(a, b);
    }
    public int mod(int a, int b) {
        return Bib.mod(a, b);
    }
    public int intPow(int a, int b) {
        return Bib.intPow(a, b);
    }
    public String toFpp(String infix) {
        return Bib.toFpp(infix);
    }
    public ServiceXs(String urlServ) {
        Hashtable url = Hurl.hurl(urlServ);
        String pathServ = (String)url["path"];
        int port = int.Parse((String)url["port"]);
        XmlRpcServer serviciu = new XmlRpcServer(port);
        serviciu.Add(pathServ, this);
        Console.WriteLine("C# XML-RPC " + pathServ + " wait at: "+urlServ);
        serviciu.Start();
    }
    public static void Main(String[] args) {
        if (args.Length > 1) new ServiceXs(args[0]);
        else new ServiceXs("http://localhost:1001/Xs");
    }
}
