from spyne.decorator import rpc
from spyne.service import ServiceBase
from spyne.model.primitive import String
from spyne.model.primitive import Integer
from spyne.util.simple import wsgi_soap11_application
from wsgiref.simple_server import make_server
import sys
import Bib
import Hurl
class ServiceSy (ServiceBase):
    @rpc(_returns=String)
    def ping(self):
        return Bib.ping("SOAP", "ServiceSy", "2004")
    @rpc(Integer, Integer, _returns=Integer)
    def add(self, a, b):
        return int(`Bib.add(a, b)`)
    @rpc(Integer, Integer, _returns=Integer)
    def subtract(self, a, b):
        return int(`Bib.subtract(a, b)`)
    @rpc(Integer, Integer, _returns=Integer)
    def multiply(self, a, b):
        return int(`Bib.multiply(a, b)`)
    @rpc(Integer, Integer, _returns=Integer)
    def divide(self, a, b):
        return int(`Bib.divide(a, b)`)
    @rpc(Integer, Integer, _returns=Integer)
    def mod(self, a, b):
        return int(`Bib.mod(a, b)`)
    @rpc(Integer, Integer, _returns=Integer)
    def intPow(self, a, b):
        return int(`Bib.intPow(a, b)`)
    @rpc(String, _returns=String)
    def toFpp(self, infix):
        return Bib.toFpp(infix)
    def start(self, urlServ):
        url = Hurl.hurl(urlServ)
        print "Python SOAP ServiceSy waiting at:" + urlServ
        app = wsgi_soap11_application([ServiceSy], "http://y/")
        serviciu = make_server(url["host"], int(url["port"]), app)
        serviciu.serve_forever()
serviciu = ServiceSy() # Nu merge cu definirea in Sy1Serv a unui constructor cu parametri 
if len(sys.argv) > 1:
    serviciu.start(sys.argv[1])
else:
    serviciu.start("http://0.0.0.0:2004")
